#include <stdint.h>

/*C implementation of the algorithm from shx-rand.asm, for both error-checking*/
/*(this one is known to be correct, as it's taken directly from the source    */
/*article) and for performance comparison. See shx-rand.asm for details.      */

uint32_t history[4];

uint32_t getrand()
{
	uint32_t t = (history[0] ^ (history[0] << 11));
	history[0] = history[1];
	history[1] = history[2];
	history[2] = history[3];
	return (history[3] = (history[3] ^ (history[3] >> 19)) ^ (t ^ (t >> 8)));
}